.base-button {
  // local variables
  $transition: all ease-out 0.1s;
  $blur: blur(12px);

  $shadow-color: rgba(0, 0, 0, 0.08);
  $shadow-color-active: rgba(0, 0, 0, 0.12);

  $green-color: #eefdf8;
  $green-color-active: #a2fddf;

  $blue-color: #e5f8fe;
  $blue-color-active: #99e7ff;

  $distanse: 1rem;

  --fallback-blur-color: rgba(255, 255, 255, 0.85);
  --blur-color: rgba(255, 255, 255, 0.4);

  @include reset-button;

  position: relative;
  z-index: 10;

  cursor: pointer;

  transition: $transition;

  margin: {
    top: $distanse * 0.5;
    left: $distanse * 0.5;
    bottom: $distanse * 1.5;
    right: $distanse * 1.5;
  }

  &:before {
    content: '';
    @include size(100%, 100%);
    position: absolute;
    top: $distanse;
    left: $distanse;

    background-color: $shadow-color;
    backdrop-filter: $blur;
    transition: $transition;

    z-index: -10;
  }

  &__color-decoration {
    @include size(100%, 100%);
    @include absolute-center;
    z-index: -1;

    &:after,
    &:before {
      content: '';
      @include size(2.5rem, 2.5rem);
      position: absolute;
      transition: $transition;
      opacity: 0.7;
    }

    &:before {
      background-color: $blue-color;
      left: -$distanse / 2;
      top: -$distanse / 2;
    }
    &:after {
      background-color: $green-color;
      right: -$distanse * 1.5;
      bottom: -$distanse * 1.5;
    }
  }

  &__label {
    display: block;
    min-width: 12.5rem;
    width: 100%;
    box-sizing: border-box;
    padding: 0.75rem;

    position: relative;
    left: 0;
    top: 0;

    text-align: left;

    box-shadow: 6px 6px 24px rgba(255, 255, 255, 0.52);
    @extend %base-blur;
    // background-color: rgba(255, 255, 255, 0.4);
    // backdrop-filter: blur(24px);

    transition: $transition;
    @include font($primary-font, 1.5rem, $font-primary-color);
  }

  &:hover,
  &:active {
    transition: $transition;

    &:before {
      background: $shadow-color-active;
      transition: $transition;
    }

    .base-button__color-decoration {
      &:before {
        background-color: $blue-color-active;
        transition: $transition;
      }

      &:after {
        background-color: $green-color-active;
        transition: $transition;
      }
    }
  }

  &:active {
    &:before {
      left: $distanse * 0.5;
      top: $distanse * 0.5;
      transition: $transition;
    }

    .base-button__label {
      left: $distanse * 0.25;
      top: $distanse * 0.25;
      transition: $transition;
    }

    .base-button__color-decoration {
      &:before {
        top: -$distanse * 0.1;
        left: -$distanse * 0.1;
        transition: $transition;
      }

      &:after {
        right: -$distanse * 0.8;
        bottom: -$distanse * 0.8;
        transition: $transition;
      }
    }
  }
}
// TABLET
@include tablet {
  .base-button {
    &__label {
      font-size: 1.25rem;
    }
  }
}

// PHONE
@include phone {
  .base-button {
    &__label {
      font-size: 0.875rem;
    }
  }
}
